"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReducedMemoryRepresentation = function (total) {
    if (total === void 0) { total = 0; }
    if (isNaN(total)) {
        return 0;
    }
    else {
        total = total + 0;
        switch (true) {
            case total < 1000:
                return total.toFixed(1) + "B";
            case total < 1000000:
                return (total / 1000).toFixed(1) + "KB";
            case total < 1000000000:
                return (total / 1000000).toFixed(1) + "MB";
            case total < 1000000000000:
                return (total / 1000000000).toFixed(1) + "GB";
        }
    }
};
exports.ImageHandler = {
    dataURItoBlob: function (dataURI) {
        // convert base64/URLEncoded data component to raw binary data held in a string
        var byteString;
        if (dataURI.split(',')[0].indexOf('base64') >= 0) {
            byteString = atob(dataURI.split(',')[1]);
        }
        else {
            byteString = decodeURI(dataURI.split(',')[1]);
        }
        // separate out the mime component
        var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
        // write the bytes of the string to a typed array
        var ia = new Uint8Array(byteString.length);
        for (var i = 0; i < byteString.length; i++) {
            ia[i] = byteString.charCodeAt(i);
        }
        return new Blob([ia], { type: mimeString });
    },
    blobToFile: function (blob) {
        return new File([blob], "inputFile");
    },
    dataURItoFile: function (dataURI) {
        var blob = exports.ImageHandler.dataURItoBlob(dataURI);
        return exports.ImageHandler.blobToFile(blob);
    }
};
//# sourceMappingURL=helpers.js.map